digiKam Developer Documentation: Digikam::HistoryImageId Class Reference

| digiKam Developer Documentation Professional Photo Management with the Power of Open Source

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
Digikam::HistoryImageId Class Reference

## Public Types
enum | Type { InvalidType = 0 , Original = 1 << 0 , Intermediate = 1 << 1 , Source = 1 << 2 , Current = 1 << 3 }
typedef QFlags< Type > | Types

## Public Member Functions
| HistoryImageId ()=default
| Creates an invalid HistoryImageId.
| HistoryImageId (const QString &uuid, Type type=Current)
| Creates an id with the given UUID and type.
QDateTime | creationDate () const
QString | fileName () const
| If a file on disk is referenced: Returns the file name (without folder)
QString | filePath () const
| If a file on disk is referenced: Returns the full file path (folder + filename)
qlonglong | fileSize () const
bool | hasCreationDate () const
bool | hasFileName () const
bool | hasFileOnDisk () const
bool | hasUniqueHashIdentifier () const
bool | hasUuid () const
bool | isCurrentFile () const
bool | isIntermediateFile () const
bool | isOriginalFile () const
bool | isSourceFile () const
bool | isValid () const
| A valid id needs at least a valid type and a UUID or a filename.
bool | operator== (const HistoryImageId &other) const
QString | originalUuid () const
QString | path () const
| If a file on disk is referenced: Returns the path, without filename, with a trailing slash.
void | setCreationDate (const QDateTime &creationDate)
void | setFileName (const QString &fileName)
void | setPath (const QString &path)
void | setPathOnDisk (const QString &filePath)
void | setType (HistoryImageId::Type type)
void | setUniqueHash (const QString &uniqueHash, qlonglong fileSize)
void | setUuid (const QString &uuid)
Type | type () const
QString | uniqueHash () const
QString | uuid () const

## Public Attributes
QDateTime | m_creationDate
| The creation date of the original image.
QString | m_fileName
| The filename of the referred file.
QString | m_filePath
| The path of the referred file.
qlonglong | m_fileSize = 0
| The file size of the referred file.
QString | m_originalUUID
| A unique identifier designating the original image from which the referred image was created.
Type | m_type = InvalidType
| Type of this History Image Id.
QString | m_uniqueHash
| The unique hash of the referred file.
QString | m_uuid
| A unique identifier for the referred file.

## Member Typedef Documentation

## ◆ Types

typedef QFlags< Type > Digikam::HistoryImageId::Types

Note
  In this class, the Type is used as a simple enum, but it is also prepared for usage as flags.

## Member Enumeration Documentation

## ◆ Type

enum Digikam::HistoryImageId::Type

Enumerator
Original | The original file (typically created by a camera)
Intermediate | A file created during the editing the history, between the original file and the current file.
Source | When a file is created from multiple files, there can be no direct original (panorama) but multiple sources, or one direct original and some other, additional source files. To record source files outside of the direct history, this type is used.
Current | The "current" file. This is a special entry: It refers to the file from which this history was read. It need not be written to the file, because it describes the file itself. There is typically exactly one current entry if the history is associated with an image; there can be no current entry.

## Member Data Documentation

## ◆ m_filePath

QString Digikam::HistoryImageId::m_filePath

Note
  Without file name, including trailing slash

## ◆ m_originalUUID

QString Digikam::HistoryImageId::m_originalUUID

Typically, this is a RAW or JPEG created by the camera in the moment of taking the photograph.

## ◆ m_uuid

QString Digikam::HistoryImageId::m_uuid

This id shall be changed each time the image is edited.